%global relversion rc3
%global buildopts BLAS=open BLAS_INCLUDE=%{_includedir}/openblas CPU_ONLY=1

Name:           caffe
Version:        1.0.0
Release:        0.2.%{relversion}%{?dist}
Summary:        a fast open framework for deep learning

License:        BSD
URL:            http://caffe.berkeleyvision.org/
Source0:        https://github.com/BVLC/caffe/archive/%{relversion}/%{name}-%{relversion}.tar.gz

ExcludeArch:    %ix86

BuildRequires:  boost-devel
BuildRequires:  cmake
BuildRequires:  gflags-devel
BuildRequires:  glog-devel
BuildRequires:  hdf5-devel
BuildRequires:  leveldb-devel
BuildRequires:  lmdb-devel
BuildRequires:  openblas-devel
BuildRequires:  opencv-devel
BuildRequires:  protobuf-devel
BuildRequires:  python2-devel
BuildRequires:  snappy-devel

%if 0%{?fedora} >= 24
BuildRequires:  python2-numpy
%else
BuildRequires:  numpy
%endif


%description
Caffe is a deep learning framework made with expression, speed, and modularity
in mind. It is developed by the Berkeley Vision and Learning Center (BVLC) and
by community contributors. Yangqing Jia created the project during his PhD at UC
Berkeley.


%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}


%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%autosetup -n %{name}-%{relversion}


%build
cp Makefile.config.example Makefile.config
%make_build %{buildopts} all


%install
%make_build %{buildopts} distribute
install -p -m755 -D --target-directory %{buildroot}%{_bindir} distribute/bin/*
install -p -m755 -D --target-directory %{buildroot}%{_libdir} distribute/lib/*.so.*
cp -p distribute/lib/*.so %{buildroot}%{_libdir}
install -p -m644 -D --target-directory %{buildroot}%{_includedir}/caffe distribute/include/caffe/*.hpp
install -p -m644 -D --target-directory %{buildroot}%{_includedir}/caffe/layers distribute/include/caffe/layers/*
install -p -m644 -D --target-directory %{buildroot}%{_includedir}/caffe/util distribute/include/caffe/util/*
install -p -m644 -D --target-directory %{buildroot}%{_includedir}/caffe/msgs distribute/proto/*


%check
%make_build %{buildopts} runtest

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%license LICENSE
%{_bindir}/*
%{_libdir}/libcaffe.so.%{version}-%{relversion}

%files devel
%{_libdir}/libcaffe.so
%{_includedir}/caffe


%changelog
* Tue Oct 18 2016 Till Hofmann <till.hofmann@posteo.de> - 1.0.0-0.2.rc3
- Fix numpy dependency for older releases

* Mon Oct 17 2016 Till Hofmann <till.hofmann@posteo.de> - 1.0.0-0.1.rc3
- Initial package
